
  *   Star Wars   Atari ST cartridge  version
  

*Rom cartridge

  org $FA0000
 
  dc.l	$abcdef42     *magic
  dc.l	second
  dc.l 	$08000000+autorev    * Bit 27 set
* what means run before Disk-boot

  dc.l	autorev
  dc.w 	%0111101000100100   *time, GEMDOS format, 15 h, 17 min
  dc.w	%0011101011011010  *date - 2009, VI, 26 
  dc.l 	desksw-autorev
  dc.b	 "AUTOSW",0
    even

second
  dc.l 	0    * No more
  dc.l 	$40000000   * TOS app.
  dc.l 	desksw
  dc.w 	%0111101000100100   *time, GEMDOS format
  dc.w 	%0011101011011010 *date - 2009, VI, 26 
  dc.l 	end-desksw
  dc.b	"STARWARS.TOS",0
  even


desksw     * Dummy




autorev	

	pea	cheatt(pc)
	move.w	#9,-(sp)
	trap	#1

	clr.w	$600.w


	
*Little pause to see it:
	move.w	#1177,d7

dell1	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp

* On key release goes further !
	
	move.b	$FFFFFC02.w,d0

	cmp.b	#$96,d0    * U released
	beq.s	unlims

	cmp.b	#$B1,d0    * N released
	beq.s	toPicsh

wait_k	dbf	d7,dell1
	bra.s	toPicsh


unlims	st	$600.w
	

toPicsh

* Copy file access code to unused RAM area :


	move.l	4.w,d2
	clr.b	d2
	move.l	d2,a2

	move.l	12(a2),a2   * RAM area not used by GEMDOS start
* But in TOS 1.02 it is at $8900, so can not use short addressing !
* Therefore will move it to $6000 then 	

	cmp.l	#$7B00,a2
	bcs.s	savWsa

	lea	$6000.w,a2   * for TOS 1.02

savWsa	move.l	a2,$606.w   * save it


	lea  coup(pc),a1
	move.l  a2,a3
	move.w #335,d2    * with CAT too !
mou	move.l  (a1)+,(a2)+
	dbf  d2,mou
*	jmp  (a3)




* Set Trap #1 for loading from final RAMdisk :

	move.l	$84.w,toromR+2-coup(a3)	
	move.l	a3,$84.w

* Ramdisk will go to Phystop-121000
	move.l	$42E.w,a1
	sub.l	#121000,a1
	move.l	a1,$610.w

* Must set DTA ! - it is 0 at this point 


	lea	2000(a3),a3
	pea	(a3)
	move.w	#26,-(sp)
	trap	#1
	addq.l	#6,sp



	
	move.l	$432.w,a3   * Membot

	lea	256(a3),a2
	
	move.l	$84.w,a1     * coup here
	

* Set 3 addresses :

	lea	$B156-$AA56(a2),a0
	move.l	a0,jsrB156+2-coup(a1)


* In ret after delay : 
	lea	$BC36-$AA56(a2),a0
	move.l	a0,jmpBC36+2-coup(a1)

* Ramdisk address set:
	move.l	$610.w,setRdsa+2-coup(a1)


	move.l	$436.w,a4    *Memtop
	
*	move.w	#$0300,sr   *Set user mode

	move.l	sp,$602.w   * save SSP

	lea	-8(a4),sp
	clr.l	(sp)
	move.l	a3,4(sp)

* Proper way is to do malloc here :


	sub.l	a3,a4
	pea	(a4)
	move.w	#$48,-(sp)
	trap	#1
	addq.l	#6,sp

* d0 should be here=4(sp)  !



	lea	gamexc3+32(pc),a1
	move.l	4(sp),a2      *Basepage	
	lea	228(a2),a4   *Depack with header

	move.l	a2,-(sp)

	bsr	depak3


	move.l	(sp)+,a5   *Basepage
	lea	256(a5),a1   *code

* Now reloc : 
	move.l     a1,a0
	lea  	-28(a0),a3   *Header
  	move.l     a1,d0
	add.l    	2(a3),a0   *Code  len for this prg
    	add.l    	6(a3),a0   *Data  len for this prg	

      	move.l	a0,a2 * reloc table begin


	tst.l	(a0)
	beq.s	corrbp *

	add.l	(a0)+,a1
	clr.l	d1
relol	add.l	d0,(a1)
bigd	
	move.b	(a0)+,d1
	beq.s	corrbp
	cmp.b	#1,d1
	bne.s	nmd
	lea	$FE(a1),a1
	bra.s	bigd
nmd	adda.l	d1,a1
	bra.s	relol
corrbp

	move.l	d0,8(a5)    * Replace  cart address with RAM address !

	MOVE.L	2(A3),$C(A5)
	MOVE.L	6(A3),$14(A5)
	MOVE.L	$A(A3),$1C(A5)
	MOVE.L	8(A5),D2
	MOVE.L	$C(A5),D1
	ADD.L	D2,D1
	MOVE.L	D1,$10(A5)
	MOVE.L	$14(A5),D2
	ADD.L	D2,D1
	MOVE.L	D1,$18(A5)


	lea  	6600(a0),a0


xy    	clr.l	(a2)+ * clear BSS area begin
        	cmp.l	a2,a0
       	bgt.s	xy 	  




	move.l	d0,a2




*	move.w	#$6006,$BC3A-$AA56(a2)   * skip load calls


	move.l	$84.w,a1     * coup here

	lea	chaScr-coup(a1),a0
	
	move.w	#$4EF8,$BC32-$AA56(a2)
	move.w	a0,$BC34-$AA56(a2)




* Cheats :

	tst.b	$600.w
	beq.s	nounls

	move.l	a2,a1
	add.l	#$15204-$AB52,a1
	move.w	#$6002,(a1)

nounls	


* Now jump in game

*	move.w	#$4E75,$BC36   * skip file loads etc


* Video freq access off :
	

	move.l	a2,a1
	add.l	#$13BA6-$AB52,a1
	move.w	#$4E75,(a1)


	move.l	a2,a1
	add.l	#$1B8DE-$AB52,a1
	move.w	#$6008,(a1)




	move.l	sp,a1
	move.l	a1,usp
	move.l	$602.w,sp
	move.w	#$0300,sr



	jmp	(a2)



coup
trap1R    * For file load from final RAMdisk

* fopen gets loc in RAMdisk by given name

* fread does load to dest

* fclose just returns with OK


  move.l    sp,a0
  btst    #5,(sp) *test is called from user
  bne.s    notuserR
  move.l    usp,a0
  bra.s     getFuR
notuserR   addq.l  #6,a0   * or 8 for 68030 
getFuR   



  cmp.w      #61,(a0)
  beq.s     fopenR

  cmp.w      #62,(a0)
  beq.s     fcloseR

  cmp.w      #63,(a0)
  beq.s     freadR

  cmp.w      #$4E,(a0)
  beq         fsFirst

  cmp.w      #60,(a0)
  beq         fCreate
  

toromR   jmp    0   *****

fopenR 	*  get loc in RAMdisk by filename
	
* All names are DOS type , used max 12 bytes - so final 0 may missing
*  then long with pos


	move.l	2(a0),a0   *  name pointer
*	addq.l	#2,a0    * skip   a: 
	move.l	a0,a2
	lea	catA(pc),a1

seefnLoop	move.l	a2,a0
	move.l	a1,a3

	moveq	#11,d3    * max 12 to compare
.cof	*  cmpm.b	(a0)+,(a1)+
* Must capitalise 

	move.b	(a0)+,d0
	beq.s	match
	cmp.b	#"9",d0
	ble.s	.no
	and.b	#$DF,d0
.no	cmp.b	(a1)+,d0


	bne.s	notMf

	dbf	d3,.cof

match	lea	depSa+2(pc),a1
* Need to set len too, as SW put often there too looooong :
	move.l	28(a3),d2  * next file pos
*	move.l	d2,reaNext-depSa(a1)
	move.l	12(a3),a3
*	move.l	a3,reaPos-depSa(a1)
	sub.l	a3,d2
	move.l	d2,traLen-depSa(a1)
	add.l	$610.w,a3   * RAMdisk pos
	move.l	a3,(a1)

*  Clear  fpos  :

	clr.l	fpos-depSa-2(a1)



     	moveq		#6,d0   * Typical handle value
	rte

notMf	lea	16(a3),a1   * next rec in CAT 

* some overrun check if not found :

	lea	catA+304(pc),a0
	cmp.l	a0,a1
	bge.s	filNf

	bra.s	seefnLoop

filNf	moveq	#-33,d0
	rte


fcloseR	moveq		#0,d0
	rte




freadR  * dest and len needed :




*	move.l	4(a0),d1   * len - danger of beeing more !
* Then need calculated len !

traLen	move.l	#0,d1  ***
	move.l	4(a0),d1   * len - danger of beeing more !
	move.l	d1,d0    * Return value needed by TOS
	move.l	8(a0),a2 * dest
depSa	lea	0,a1      ***  src adr of file begin

	lea	fpos(pc),a0
	add.l	(a0),a1
	add.l	d1,(a0)   * update it

	
.co	move.b	(a1)+,(a2)+
	subq.l	#1,d1
	bne.s	.co
	


	rte


fsFirst    * Get filelen  by name :


	move.l	2(a0),a0   *  name pointer
	move.l	a0,a2
	lea	catA(pc),a1

seefnLoopS	move.l	a2,a0
	move.l	a1,a3

	moveq	#11,d3    * max 12 to compare
.cof	
* Must capitalise :

	move.b	(a0)+,d0
	beq.s	matchS
	cmp.b	#"9",d0
	ble.s	.no
	and.b	#$DF,d0
.no	cmp.b	(a1)+,d0


	bne.s	notMfS

	dbf	d3,.cof

matchS	

	move.l	28(a3),d2  * next file pos
	move.l	12(a3),a3
	sub.l	a3,d2    * file len

	movem.l	d2/a2,-(sp)

	move.w	#$2F,-(sp)
	trap	#1
	addq.l	#2,sp

	movem.l	(sp)+,d2/a2

	move.l	d0,a1
	lea	26(a1),a1
	move.l	d2,(a1)+   *  len
	moveq	#13,d0
.cn	move.b	(a2)+,(a1)+
	dbf	d0,.cn
	

     	moveq		#0,d0   * OK flag
	rte

notMfS	lea	16(a3),a1   * next rec in CAT 

* some overrun check if not found :

	lea	catA+304(pc),a0
	cmp.l	a0,a1
	bge	filNf

	bra.s	seefnLoopS



fCreate    moveq  #-35,d0   * Disallow
	rte   



fpos	dc.l	0   * pos in file







depak3	clr.l d0
	moveq    #6,d4
	moveq    #$3f,d5   *for masking bits 5-0

* Bit meaning:  7 - if set it's back referrer , if 0 then bits
* 6-0 give count of literals to copy
* if all bits are 0 it is terminator

* When bit 7 set, bit 6: if 1 then long distance back given by 2 following byte
*  bit 6: when 0  then short distance given by following 1 byte
*  bits 5-0  count of bytes referred. 
*  By short refer.  0 means 3, 1 means 4, etc  up to 66 .
*  By long refer.  0 means 4, 1 means 5, etc  up to 67 .


main3 	clr.w d0 *prep for dbf
	move.b (a1)+,d0
	bmi.s back3 
	beq.s nom3 *end
	subq.w #1,d0 *compens dbf
litc 	move.b (a1)+,(a4)+
	dbf d0,litc
	bra.s main3

nom3	rts

back3	move.b d0,d2
	and.w d5,d2 *d5=$3f
* Test is long or short referrer:
	btst    d4,d0   *test bit 6
	bne.s  longr
	
	addq.w #2,d2 *compens	
displl	move.b (a1)+,d0 * displac
calcadr	move.l a4,a2
	sub.l d0,a2
baksl	move.b (a2)+,(a4)+
	dbf d2,baksl
	bra.s main3

longr	addq.w #3,d2 *compens
	move.b (a1)+,d0 * displac
	lsl.w  #8,d0   *MSB
	bra.s   displl

	
* End of C3 depak







catA	incbin  "CAT"   * 304 bytes

    even


chaScr	* Screen to $20000 or $30000 if TOS 2.06 :

	clr.w	-(sp)
	lea	$20000,a1
	cmp.l	a1,sp
	bcs.s	not206
	lea	$30000,a1
not206	pea	(a1)
	pea	(a1)
	move.w	#5,-(sp)
	trap	#14
	lea	12(sp),sp


jsrB156	jsr	0   ****   Show instructions


depRamd	    * Depack ramdisk after showing instructions :


	movem.l	a4-a6,-(sp)

	lea	rdfc+32,a1     *  abs !!!
*	move.l	$610.w,a4    * user mode will crash this !
setRdsa	lea	0,a4    ****
	bsr	depak3


	movem.l	(sp)+,a4-a6

* Need some delay after instructions : 

	move.w	#126,d7
	
.dai	move.w	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	dbf	d7,.dai

jmpBC36	jmp	0   ****




cheatt   dc.b  27,"H","Press U for unlim. shield",13,10
     dc.b  " N for normal play",0
	even




gamexc3    incbin   "SW.FIC"
   
   even


rdfc    incbin  "SWR.FIC"
   even


end




